@echo off

rem --- Config_win32.bat
rem --- Configuration file for Windows based systems using MSVC++ 2010
rem       * build by Command-line
rem       * build through IDE


rem -- external dependencies --------------------

 rem --  base directory for Tcl's include and libs
set TCLDIR=C:\tcl
 rem -- base directory for Tk's include and lib
set TKDIR=C:\tcl
 rem -- base directory of AGG source distribution
set AGGDIR=%~dp0\Agg

rem -- required tools --------------------
  
 rem -- c++ toolchain

 rem -- check if visual-studio is available
 rem --   (simple check ... try to run CL.exe command )
CL.exe > NUL: 2>&1
if NOT errorlevel 1 goto :VSTUDIO_OK 

set "vstudio=Microsoft Visual Studio 10.0"

 rem -- try with %ProgramFiles% standard path ...
set "vs_startup=%ProgramFiles%\%vstudio%\vc\vcvarsall.bat"
if exist "%vs_startup%"  call "%vs_startup%"

 rem -- try again
CL.exe > NUL: 2>&1
if NOT errorlevel 1 goto :VSTUDIO_OK

 rem -- try with (x86) path ...
set "vs_startup=%ProgramFiles(x86)%\%vstudio%\vc\vcvarsall.bat"
if exist "%vs_startup%"  call "%vs_startup%"

 rem -- last try
CL.exe > NUL: 2>&1
if errorlevel 1 (
	echo Cannot find the "%vstudio%" tools ... stop
	exit /B 1
)			

:VSTUDIO_OK	 

 rem -- SWIG (Simplified Wrapper and Interface Generator)
swig 2>NUL:
if errorlevel 1 (
     rem -- note the "" (!!)  string concatenation .... it works !
 	set "PATH=%PATH%;%ProgramFiles%\swigwin-3.0.5"
)

  rem -- dummy command for resetting exit-code
ver >NUL: